using gaemstone.ECS;

namespace gaemstone.Client.Components;

[Module]
public partial class ResourceComponents
{
	[Tag, Symbol]
	public struct Resource {  }

	// Entities can have for example Texture as a tag, in which case
	// they're the actual resource holding the data or handle.
	//
	// Entities can also have a (Texture, $T) pair where $T is a resource,
	// meaning the entity has that resource assigned as their texture.

	[Relation, Tag, Symbol, IsA<Resource>]
	public struct Texture {  }

	[Relation, Tag, Symbol, IsA<Resource>]
	public struct Mesh {  }
}
