using System;
using System.Collections.Generic;

namespace gaemstone.ECS;

[AttributeUsage(AttributeTargets.Class | AttributeTargets.Struct)]
public class ModuleAttribute : SingletonAttribute {  }

[AttributeUsage(AttributeTargets.Class)]
public class BuiltInAttribute : Attribute {  }


/// <summary>
/// A concrete implementation of this interface is generated by a source
/// generator for each type marked as <see cref="ModuleAttribute"/>.
/// </summary>
public interface IModule
{
	static abstract string Path { get; }

	static abstract bool IsBuiltIn { get; }

	static abstract IReadOnlyList<string> Dependencies { get; }

	static abstract void Initialize<TContext>(Entity<TContext> module);
}

public interface IModuleInitializer
{
	static abstract void Initialize<TContext>(Entity<TContext> module);
}
