using gaemstone.ECS;

namespace gaemstone;

public class Universe<TContext>
{
	public World<TContext> World { get; }
	public ModuleManager<TContext> Modules { get; }

	public Universe(params string[] args)
	{
		World   = new(args);
		Modules = new(this);

		// Bootstrap [Relation] tag, since it will be added to some Flecs types.
		World.New("/gaemstone/Doc/Relation").Build()
			.CreateLookup<Doc.Relation>();

		// Bootstrap built-in (static) modules from Flecs.
		Modules.Register<Flecs.Core>();
		Modules.Register<Flecs.Doc>();
		Modules.Register<Flecs.Pipeline>();

		Modules.Register<Doc>();
	}
}
